CONFIG_SOUND_OSS_CORE{,_PRECLAIM} seem to have become reenabled in 12.04 and later

Bug #1105230 reported by Steven Maddox on 2013-01-25
16
This bug affects 3 people
Affects Status Importance Assigned to Milestone
linux (Ubuntu)
Medium
Andy Whitcroft
Precise
Medium
Andy Whitcroft
Quantal
Medium
Andy Whitcroft

Bug Description

To my knowledge OSS was completely and purposefully removed from Linux and builds of Linux that Ubuntu uses.

As a result kernel compile options such as these...

CONFIG_SOUND_OSS_CORE=y
CONFIG_SOUND_OSS_CORE_PRECLAIM=y

Were _not_ in the config-3.8.01-generic of the kernel that shipped with 11.10... no mention of them at all in the file

But in 12.04, 12.10 and (so far unreleased) 13.04 I can see that they're back.

Spoken with several people in #ubuntu-kernel who believe this is an accidental regression and they shouldn't be there.

The CONFIG_SOUND_OSS_CORE_PRECLAIM is particularly a problem as it makes sure the device numbers for things like /dev/dsp are hogged all the time by the kernel... and since the kernel has no OSS backwards compatibility any more - it's just causing problems for OSS emulation software like osspd (OSS Proxy) to assume those device numbers for itself.

OSS Proxy it seems has found it's in to being packaged for Debian Sid and thus has been copied over for 13.04 - yet this package will be useless without this kernel option fix.

I'd like to request these obivously strange options be removed or turned off on compiling the kernel we'll all use in 13.04 at least.

Thanks

ProblemType: Bug
DistroRelease: Ubuntu 12.04
Package: linux-image-3.2.0-31-generic 3.2.0-31.50
ProcVersionSignature: Ubuntu 3.2.0-31.50-generic 3.2.28
Uname: Linux 3.2.0-31-generic x86_64
NonfreeKernelModules: nvidia
AlsaVersion: Advanced Linux Sound Architecture Driver Version 1.0.24.
ApportVersion: 2.0.1-0ubuntu17.1
Architecture: amd64
AudioDevicesInUse:
 USER PID ACCESS COMMAND
 /dev/snd/controlC2: lantizia 2434 F.... pulseaudio
 /dev/snd/controlC1: lantizia 2434 F.... pulseaudio
 /dev/snd/controlC0: lantizia 2434 F.... pulseaudio
 /dev/snd/pcmC0D0p: lantizia 2434 F...m pulseaudio
CRDA: Error: [Errno 2] No such file or directory
Card0.Amixer.info:
 Card hw:0 'XFi'/'Creative X-Fi 20K1 UAA'
   Mixer name : '20K1'
   Components : ''
   Controls : 27
   Simple ctrls : 10
Card1.Amixer.info:
 Card hw:1 'PCH'/'HDA Intel PCH at 0xf4310000 irq 44'
   Mixer name : 'VIA VT2020'
   Components : 'HDA:11060441,1458a014,00100100'
   Controls : 44
   Simple ctrls : 24
Card2.Amixer.info:
 Card hw:2 'NVidia'/'HDA NVidia at 0xf6080000 irq 17'
   Mixer name : 'Nvidia GPU 42 HDMI/DP'
   Components : 'HDA:10de0042,14583555,00100100'
   Controls : 18
   Simple ctrls : 3
Date: Fri Jan 25 16:13:21 2013
HibernationDevice: RESUME=UUID=5eee3ba4-0719-4ce2-9b92-83c057ff500b
MachineType: Gigabyte Technology Co., Ltd. To be filled by O.E.M.
MarkForUpload: True
ProcFB:

ProcKernelCmdLine: BOOT_IMAGE=/boot/vmlinuz-3.2.0-31-generic root=UUID=9c439721-8550-4a36-b224-e1afb520a003 ro quiet splash
RelatedPackageVersions:
 linux-restricted-modules-3.2.0-31-generic N/A
 linux-backports-modules-3.2.0-31-generic N/A
 linux-firmware 1.79.1
RfKill:

SourcePackage: linux
StagingDrivers: mei
UpgradeStatus: No upgrade log present (probably fresh install)
dmi.bios.date: 07/23/2012
dmi.bios.vendor: American Megatrends Inc.
dmi.bios.version: F9
dmi.board.asset.tag: To be filled by O.E.M.
dmi.board.name: Z77M-D3H
dmi.board.vendor: Gigabyte Technology Co., Ltd.
dmi.chassis.asset.tag: To Be Filled By O.E.M.
dmi.chassis.type: 3
dmi.chassis.vendor: Gigabyte Technology Co., Ltd.
dmi.chassis.version: To Be Filled By O.E.M.
dmi.modalias: dmi:bvnAmericanMegatrendsInc.:bvrF9:bd07/23/2012:svnGigabyteTechnologyCo.,Ltd.:pnTobefilledbyO.E.M.:pvrTobefilledbyO.E.M.:rvnGigabyteTechnologyCo.,Ltd.:rnZ77M-D3H:rvr:cvnGigabyteTechnologyCo.,Ltd.:ct3:cvrToBeFilledByO.E.M.:
dmi.product.name: To be filled by O.E.M.
dmi.product.version: To be filled by O.E.M.
dmi.sys.vendor: Gigabyte Technology Co., Ltd.

Steven Maddox (lantizia) wrote :
Andy Whitcroft (apw) wrote :

    UBUNTU: [Config] re-disable CONFIG_SOUND_OSS

    We intended to turn off CONFIG_SOUND_OSS in maverick timeframe:

        https://lists.ubuntu.com/archives/kernel-team/2010-May/010647.html

    We inadvertantly reenabled it for some early ARM work in the commit
    below:

      commit d5a54f43f357d4814f2c3d53ca3d5c3f6fddebe0
      Author: Andy Whitcroft <email address hidden>
      Date: Thu Jan 12 14:32:10 2012 +0000

        UBUNTU: [Config] pull ARM sound modules =m

    These being enabled prevent the very userspace shims we intended to use
    for OSS consumers, given that none of them are enabled in the current
    kernel. The will trivially turn off now as they are not being used by
    any drivers.

    BugLink: http://bugs.launchpad.net/bugs/1105230
    Signed-off-by: Andy Whitcroft <email address hidden>

Changed in linux (Ubuntu):
status: New → Fix Committed
importance: Undecided → Medium
Changed in linux (Ubuntu Precise):
assignee: nobody → Andy Whitcroft (apw)
Changed in linux (Ubuntu):
assignee: nobody → Andy Whitcroft (apw)
Changed in linux (Ubuntu Quantal):
assignee: nobody → Andy Whitcroft (apw)
summary: - Removal of odd OSS options in kernel compile config file
+ CONFIG_SOUND_OSS_CORE{,_PRECLAIM} seem to have become reenabled in 12.04
+ and later
Andy Whitcroft (apw) wrote :

I have shoved these off in Raring as actually they are enabled but no drivers using them are enabled. I will see if this is as trivial in P and Q.

Andy Whitcroft (apw) wrote :

We had to actually turn off a couple of OSS mixer emulations which should also be completely redundant. While this is reasonable to do in raring, it is less clear for SRU. Will see if _PRECLAIM alone is enough in those.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux - 3.8.0-2.6

---------------
linux (3.8.0-2.6) raring; urgency=low

  [ Adam Conrad ]

  * Fix up linux-tools -> SRCPKGNAME-tools rename

  [ Andy Whitcroft ]

  * [Config] re-disable CONFIG_SOUND_OSS
    - LP: #1105230

  [ Arend van Spriel ]

  * SAUCE: brcmsmac: fix tx status processing

  [Leann Ogasawara]

  * Release Tracking Bug
    - LP: #1105104
 -- Leann Ogasawara <email address hidden> Fri, 25 Jan 2013 11:56:30 -0800

Changed in linux (Ubuntu):
status: Fix Committed → Fix Released
Changed in linux (Ubuntu Precise):
importance: Undecided → Medium
Changed in linux (Ubuntu Quantal):
importance: Undecided → Medium
Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in linux (Ubuntu Precise):
status: New → Confirmed
Changed in linux (Ubuntu Quantal):
status: New → Confirmed
Andy Whitcroft (apw) wrote :

@lantizia -- i have built test kernels with _PRECLAIM disabled for both Precise and Quantal, if you could test those and report back here for me then I can push the fixes for approval and application. The kernels are here:

    http://people.canonical.com/~apw/lp1105230-precise/

and:

    http://people.canonical.com/~apw/lp1105230-quantal/

Note for quantal you will need the -extras package as well as the regular ones.

Changed in linux (Ubuntu Precise):
status: Confirmed → In Progress
Changed in linux (Ubuntu Quantal):
status: Confirmed → In Progress
Steven Maddox (lantizia) wrote :

Tested both and found that precise and quantal still boot up normally and software such as OSS Proxy Daemon (osspd package now in raring onwards) can now use the namespace that was normally reserved for OSS. I can now hear the audio of Loki games designed for OSS without the need for OSS itself!

Thank you very much for re-fixing this.

Andy Whitcroft (apw) on 2013-03-06
Changed in linux (Ubuntu Precise):
status: In Progress → Fix Committed
Changed in linux (Ubuntu Quantal):
status: In Progress → Fix Committed
Brad Figg (brad-figg) wrote :

This bug is awaiting verification that the kernel in -proposed solves the problem. Please test the kernel and update this bug with the results. If the problem is solved, change the tag 'verification-needed' to 'verification-done'.

If verification is not done by one week from today, this fix will be dropped from the source code, and this bug will be closed.

See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you!

tags: added: verification-needed-quantal
Brad Figg (brad-figg) on 2013-03-21
tags: added: verification-needed-precise
Brad Figg (brad-figg) wrote :

This resolves a bug that the kernel team introduced. I'm marking this as verification-done.

tags: added: verification-done-precise verification-done-quantal
removed: verification-needed-precise verification-needed-quantal
Launchpad Janitor (janitor) wrote :
Download full text (12.1 KiB)

This bug was fixed in the package linux - 3.2.0-40.64

---------------
linux (3.2.0-40.64) precise-proposed; urgency=low

  [Steve Conklin]

  * Release Tracking Bug
    - LP: #1160017

  [ Stefan Bader ]

  * SAUCE: Revert "SAUCE: xen/pv-spinlock: Never enable interrupts in
    xen_spin_lock_slow()"

  [ Xiangliang Yu ]

  * SAUCE: PCI: define macro for marvell vendor ID
    - LP: #1159863
  * SAUCE: PCI: fix system hang issue of Marvell SATA host controller
    - LP: #1159863

linux (3.2.0-40.63) precise-proposed; urgency=low

  [Steve Conklin]

  * Release Tracking Bug
    - LP: #1157785

  [ Andy Whitcroft ]

  * [Config] re-disable CONFIG_SOUND_OSS_PRECLAIM
    - LP: #1105230

  [ Luis Henriques ]

  * [Config] CONFIG_NFS_V4_1=y
    - LP: #1111416

  [ Upstream Kernel Changes ]

  * Revert "drm: Add EDID_QUIRK_FORCE_REDUCED_BLANKING for ASUS VW222S"
    - LP: #1150557
  * tmpfs: fix use-after-free of mempolicy object
    - LP: #1143815
    - CVE-2013-1767
  * sunvdc: Fix off-by-one in generic_request().
    - LP: #1150557
  * genirq: Avoid deadlock in spurious handling
    - LP: #1150557
  * KVM: s390: Handle hosts not supporting s390-virtio.
    - LP: #1150557
  * workqueue: consider work function when searching for busy work items
    - LP: #1150557
  * v4l: Reset subdev v4l2_dev field to NULL if registration fails
    - LP: #1150557
  * omap_vout: find_vma() needs ->mmap_sem held
    - LP: #1150557
  * dca: check against empty dca_domains list before unregister provider
    - LP: #1150557
  * powerpc/eeh: Fix crash when adding a device in a slot with DDW
    - LP: #1150557
  * ext4: return ENOMEM if sb_getblk() fails
    - LP: #1150557
  * pcmcia/vrc4171: Add missing spinlock init
    - LP: #1150557
  * Purge existing TLB entries in set_pte_at and ptep_set_wrprotect
    - LP: #1150557
  * ARM: PXA3xx: program the CSMSADRCFG register
    - LP: #1150557
  * USB: option: add and update Alcatel modems
    - LP: #1150557
  * quota: autoload the quota_v2 module for QFMT_VFS_V1 quota format
    - LP: #1150557
  * ext4: fix possible use-after-free with AIO
    - LP: #1150557
  * s390/kvm: Fix store status for ACRS/FPRS
    - LP: #1150557
  * staging: comedi: disallow COMEDI_DEVCONFIG on non-board minors
    - LP: #1150557
  * ALSA: usb-audio: fix Roland A-PRO support
    - LP: #1150557
  * x86-32, mm: Rip out x86_32 NUMA remapping code
    - LP: #1150557
  * ALSA: hda - Release assigned pin/cvt at error path of hdmi_pcm_open()
    - LP: #1150557
  * ext4: fix race in ext4_mb_add_n_trim()
    - LP: #1150557
  * zram: Fix deadlock bug in partial read/write
    - LP: #1150557
  * Driver core: treat unregistered bus_types as having no devices
    - LP: #1150557
  * ALSA: aloop: Fix Oops while PM resume
    - LP: #1150557
  * UBIFS: fix double free of ubifs_orphan objects
    - LP: #1150557
  * tty: set_termios/set_termiox should not return -EINTR
    - LP: #1150557
  * hrtimer: Prevent hrtimer_enqueue_reprogram race
    - LP: #1150557
  * nfsd: Fix memleak
    - LP: #1150557
  * staging: comedi: check s->async for poll(), read() and write()
    - LP: #1150557
  * ACPI: Add DMI entry for Sony VGN-FW41E_H
    - LP: #1150557
  * vgacon/vt: clear buf...

Changed in linux (Ubuntu Precise):
status: Fix Committed → Fix Released

The verification of this Stable Release Update has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regresssions.

Launchpad Janitor (janitor) wrote :
Download full text (13.2 KiB)

This bug was fixed in the package linux - 3.5.0-27.46

---------------
linux (3.5.0-27.46) quantal-proposed; urgency=low

  [Steve Conklin]

  * Release Tracking Bug
    - LP: #1159991

  [ Steve Conklin ]

  * Start New Release

  [ Upstream Kernel Changes ]

  * crypto: user - fix info leaks in report API
    - LP: #1156790, #1156795, #1156799
    - CVE-2013-2546
  * brcmsmac: fix mismatch in number of custom regulatory rules
    - LP: #1156769

  [ Xiangliang Yu ]

  * SAUCE: PCI: define macro for marvell vendor ID
    - LP: #1159863
  * SAUCE: PCI: fix system hang issue of Marvell SATA host controller
    - LP: #1159863

linux (3.5.0-27.45) quantal-proposed; urgency=low

  [Steve Conklin]

  * no change

linux (3.5.0-27.44) quantal-proposed; urgency=low

  [Steve Conklin]

  * no change

linux (3.5.0-27.43) quantal-proposed; urgency=low

  [Steve Conklin]

  * Release Tracking Bug
    - LP: #1156821

  [ Adam Lee ]

  * SAUCE: Bluetooth: Add support for 04ca:2007
    - LP: #1153448

  [ Andy Whitcroft ]

  * [Config] re-disable CONFIG_SOUND_OSS_PRECLAIM
    - LP: #1105230

  [ Brad Figg ]

  * Start new release

  [ Kamal Mostafa ]

  * SAUCE: alx: use github.com/qca/alx repo
    - LP: #1154238

  [ Luis Henriques ]

  * [Config] CONFIG_NFS_V4_1=y
    - LP: #1111416

  [ Qualcomm Atheros, Inc ]

  * SAUCE: alx: Update to heads/master
    - LP: #1154238

  [ Upstream Kernel Changes ]

  * Revert "drm: Add EDID_QUIRK_FORCE_REDUCED_BLANKING for ASUS VW222S"
    - LP: #1144961
  * genirq: Avoid deadlock in spurious handling
    - LP: #1144961
  * KVM: s390: Handle hosts not supporting s390-virtio.
    - LP: #1144961
  * v4l: Reset subdev v4l2_dev field to NULL if registration fails
    - LP: #1144961
  * powerpc/eeh: Fix crash when adding a device in a slot with DDW
    - LP: #1144961
  * pcmcia/vrc4171: Add missing spinlock init
    - LP: #1144961
  * USB: DWC3: Generate interrupt on each TRB as default option
    - LP: #1144961
  * usb: dwc3: gadget: fix skip LINK_TRB on ISOC
    - LP: #1144961
  * usb: dwc3: gadget: req->queued must be forced to false in cleanup
    - LP: #1144961
  * Purge existing TLB entries in set_pte_at and ptep_set_wrprotect
    - LP: #1144961
  * ARM: PXA3xx: program the CSMSADRCFG register
    - LP: #1144961
  * ab8500-chargalg: Only root should have write permission on sysfs file
    - LP: #1144961
  * USB: option: add and update Alcatel modems
    - LP: #1144961
  * uprobes/powerpc: Add dependency on single step emulation
    - LP: #1144961
  * drivers/video: fsl-diu-fb: fix pixel formats for 24 and 16 bpp
    - LP: #1144961
  * s390/kvm: Fix store status for ACRS/FPRS
    - LP: #1144961
  * staging: comedi: disallow COMEDI_DEVCONFIG on non-board minors
    - LP: #1144961
  * ALSA: usb-audio: fix Roland A-PRO support
    - LP: #1144961
  * x86-32, mm: Rip out x86_32 NUMA remapping code
    - LP: #1144961
  * x86-32, mm: Remove reference to resume_map_numa_kva()
    - LP: #1144961
  * x86-32, mm: Remove reference to alloc_remap()
    - LP: #1144961
  * ALSA: hda - Release assigned pin/cvt at error path of hdmi_pcm_open()
    - LP: #1144961
  * ab8500_btemp: Demote initcall sequence
    - LP: #1144961
  * Driver co...

Changed in linux (Ubuntu Quantal):
status: Fix Committed → Fix Released
To post a comment you must log in.